"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.copyToClipboard = void 0;
function copyClipboardApi(text) {
    return __awaiter(this, void 0, void 0, function* () {
        // Use the Async Clipboard API when available. Requires a secure browsing
        // context (i.e. HTTPS)
        if (!navigator.clipboard) {
            throw new Error('The request is not allowed');
        }
        return navigator.clipboard.writeText(text);
    });
}
function copyExecCommand(text) {
    return __awaiter(this, void 0, void 0, function* () {
        const textArea = window.document.createElement('textarea');
        textArea.value = text;
        // Avoid scrolling to bottom
        textArea.style.top = '0';
        textArea.style.left = '0';
        textArea.style.position = 'fixed';
        window.document.body.appendChild(textArea);
        textArea.focus();
        textArea.select();
        try {
            const successful = window.document.execCommand('copy');
            // var msg = successful ? 'successful' : 'unsuccessful';
            // console.log('Fallback: Copying text command was ' + msg);
            if (!successful) {
                throw new Error('Copy Failed');
            }
        }
        catch (err) {
            throw new Error('Copy Failed');
        }
        finally {
            window.document.body.removeChild(textArea);
        }
    });
}
function copyToClipboard(text) {
    return __awaiter(this, void 0, void 0, function* () {
        if (!navigator.clipboard) {
            return yield copyExecCommand(text);
        }
        try {
            return yield copyClipboardApi(text);
        }
        catch (error) {
            throw new Error('Copy Failed');
        }
    });
}
exports.copyToClipboard = copyToClipboard;
exports.default = copyClipboardApi;
